diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-tx-parameters.h ns-3.43/src/wifi/model/wifi-tx-parameters.h
--- ns-3.42/src/wifi/model/wifi-tx-parameters.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-tx-parameters.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-tx-timer.cc ns-3.43/src/wifi/model/wifi-tx-timer.cc
--- ns-3.42/src/wifi/model/wifi-tx-timer.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-tx-timer.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-tx-timer.h ns-3.43/src/wifi/model/wifi-tx-timer.h
--- ns-3.42/src/wifi/model/wifi-tx-timer.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-tx-timer.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-tx-vector.cc ns-3.43/src/wifi/model/wifi-tx-vector.cc
--- ns-3.42/src/wifi/model/wifi-tx-vector.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-tx-vector.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Nicola Baldo <nbaldo@cttc.es>
  *          Ghada Badawy <gbadawy@gmail.com>
@@ -37,7 +26,7 @@
     : m_txPowerLevel(1),
       m_preamble(WIFI_PREAMBLE_LONG),
       m_channelWidth(20),
-      m_guardInterval(800),
+      m_guardInterval(NanoSeconds(800)),
       m_nTx(1),
       m_nss(1),
       m_ness(0),
@@ -58,11 +47,11 @@
 WifiTxVector::WifiTxVector(WifiMode mode,
                            uint8_t powerLevel,
                            WifiPreamble preamble,
-                           uint16_t guardInterval,
+                           Time guardInterval,
                            uint8_t nTx,
                            uint8_t nss,
                            uint8_t ness,
-                           uint16_t channelWidth,
+                           MHz_u channelWidth,
                            bool aggregation,
                            bool stbc,
                            bool ldpc,
@@ -181,13 +170,13 @@
     return m_preamble;
 }
 
-uint16_t
+MHz_u
 WifiTxVector::GetChannelWidth() const
 {
     return m_channelWidth;
 }
 
-uint16_t
+Time
 WifiTxVector::GetGuardInterval() const
 {
     return m_guardInterval;
@@ -309,13 +298,13 @@
 }
 
 void
-WifiTxVector::SetChannelWidth(uint16_t channelWidth)
+WifiTxVector::SetChannelWidth(MHz_u channelWidth)
 {
     m_channelWidth = channelWidth;
 }
 
 void
-WifiTxVector::SetGuardInterval(uint16_t guardInterval)
+WifiTxVector::SetGuardInterval(Time guardInterval)
 {
     m_guardInterval = guardInterval;
 }
@@ -452,7 +441,7 @@
     {
         return false;
     }
-    std::string modeName = m_mode.GetUniqueName();
+    const auto& modeName = m_mode.GetUniqueName();
     if (m_channelWidth == 20)
     {
         if (m_nss != 3 && m_nss != 6)
@@ -670,8 +659,9 @@
     NS_ABORT_MSG_IF(
         m_channelWidth < 80,
         "Preamble puncturing only possible for transmission bandwidth of 80 MHz or larger");
+    [[maybe_unused]] const std::size_t num20MhzSubchannels = m_channelWidth / 20;
     NS_ABORT_MSG_IF(!inactiveSubchannels.empty() &&
-                        inactiveSubchannels.size() != (m_channelWidth / 20),
+                        inactiveSubchannels.size() != num20MhzSubchannels,
                     "The size of the inactive subchannnels bitmap should be equal to the number of "
                     "20 MHz subchannels");
     m_inactiveSubchannels = inactiveSubchannels;
@@ -828,7 +818,8 @@
         const auto index =
             (ruBw < 20) ? ((ruIndex - 1) / rusPerSubchannel.size()) : ((ruIndex - 1) * (ruBw / 20));
         const auto numSubchannelsForRu = (ruBw < 20) ? 1 : (ruBw / 20);
-        NS_ABORT_IF(index >= (m_channelWidth / 20));
+        [[maybe_unused]] const std::size_t num20MhzSubchannels = m_channelWidth / 20;
+        NS_ABORT_IF(index >= num20MhzSubchannels);
         auto ruAlloc = HeRu::GetEqualizedRuAllocation(ruType, false);
         if (ruAllocations.at(index) != HeRu::EMPTY_242_TONE_RU)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-tx-vector.h ns-3.43/src/wifi/model/wifi-tx-vector.h
--- ns-3.42/src/wifi/model/wifi-tx-vector.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-tx-vector.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Nicola Baldo <nbaldo@cttc.es>
  *          Ghada Badawy <gbadawy@gmail.com>
@@ -26,6 +15,7 @@
 #include "wifi-phy-common.h"
 
 #include "ns3/he-ru.h"
+#include "ns3/nstime.h"
 
 #include <list>
 #include <optional>
@@ -125,7 +115,7 @@
      * \param nTx the number of TX antennas
      * \param nss the number of spatial STBC streams (NSS)
      * \param ness the number of extension spatial streams (NESS)
-     * \param channelWidth the channel width in MHz
+     * \param channelWidth the channel width
      * \param aggregation enable or disable MPDU aggregation
      * \param stbc enable or disable STBC
      * \param ldpc enable or disable LDPC (BCC is used otherwise)
@@ -136,11 +126,11 @@
     WifiTxVector(WifiMode mode,
                  uint8_t powerLevel,
                  WifiPreamble preamble,
-                 uint16_t guardInterval,
+                 Time guardInterval,
                  uint8_t nTx,
                  uint8_t nss,
                  uint8_t ness,
-                 uint16_t channelWidth,
+                 MHz_u channelWidth,
                  bool aggregation,
                  bool stbc = false,
                  bool ldpc = false,
@@ -209,25 +199,25 @@
      */
     void SetPreambleType(WifiPreamble preamble);
     /**
-     * \returns the channel width (in MHz)
+     * \returns the channel width
      */
-    uint16_t GetChannelWidth() const;
+    MHz_u GetChannelWidth() const;
     /**
-     * Sets the selected channelWidth (in MHz)
+     * Sets the selected channelWidth
      *
-     * \param channelWidth the channel width (in MHz)
+     * \param channelWidth the channel width
      */
-    void SetChannelWidth(uint16_t channelWidth);
+    void SetChannelWidth(MHz_u channelWidth);
     /**
      * \returns the guard interval duration (in nanoseconds)
      */
-    uint16_t GetGuardInterval() const;
+    Time GetGuardInterval() const;
     /**
      * Sets the guard interval duration (in nanoseconds)
      *
      * \param guardInterval the guard interval duration (in nanoseconds)
      */
-    void SetGuardInterval(uint16_t guardInterval);
+    void SetGuardInterval(Time guardInterval);
     /**
      * \returns the number of TX antennas
      */
@@ -565,8 +555,8 @@
                               It is the value that will be passed
                               to PMD_TXPWRLVL.request */
     WifiPreamble m_preamble;  /**< preamble */
-    uint16_t m_channelWidth;  /**< channel width in MHz */
-    uint16_t m_guardInterval; /**< guard interval duration in nanoseconds */
+    MHz_u m_channelWidth;     /**< channel width */
+    Time m_guardInterval;     /**< guard interval duration */
     uint8_t m_nTx;            /**< number of TX antennas */
     uint8_t m_nss;            /**< number of spatial streams */
     uint8_t m_ness;           /**< number of spatial streams in beamforming */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-types.h ns-3.43/src/wifi/model/wifi-types.h
--- ns-3.42/src/wifi/model/wifi-types.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/wifi-types.h	2024-10-09 16:41:10.132656800 -0700
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2023 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_TYPES_H
+#define WIFI_TYPES_H
+
+#include "wifi-units.h"
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ * Enumeration of the possible channel widths
+ */
+enum class WifiChannelWidthType : uint8_t
+{
+    UNKNOWN = 0,
+    CW_20MHZ,
+    CW_22MHZ,
+    CW_5MHZ,
+    CW_10MHZ,
+    CW_40MHZ,
+    CW_80MHZ,
+    CW_160MHZ,
+    CW_80_PLUS_80MHZ,
+    CW_2160MHZ,
+    MAX,
+};
+
+/**
+ * \ingroup wifi
+ * The type of an MPDU.
+ */
+enum MpduType
+{
+    /** The MPDU is not part of an A-MPDU */
+    NORMAL_MPDU,
+    /** The MPDU is a single MPDU */
+    SINGLE_MPDU,
+    /** The MPDU is the first aggregate in an A-MPDU with multiple MPDUs, but is not the last
+     * aggregate */
+    FIRST_MPDU_IN_AGGREGATE,
+    /** The MPDU is part of an A-MPDU with multiple MPDUs, but is neither the first nor the last
+     * aggregate */
+    MIDDLE_MPDU_IN_AGGREGATE,
+    /** The MPDU is the last aggregate in an A-MPDU with multiple MPDUs */
+    LAST_MPDU_IN_AGGREGATE
+};
+
+/// SignalNoiseDbm structure
+struct SignalNoiseDbm
+{
+    dBm_u signal; ///< signal strength
+    dBm_u noise;  ///< noise power
+};
+
+/// MpduInfo structure
+struct MpduInfo
+{
+    MpduType type;          ///< type of MPDU
+    uint32_t mpduRefNumber; ///< MPDU ref number
+};
+
+/// RxSignalInfo structure containing info on the received signal
+struct RxSignalInfo
+{
+    double snr; ///< SNR in linear scale
+    dBm_u rssi; ///< RSSI
+};
+
+/**
+ * \ingroup wifi
+ * \brief Enumeration of frequency channel types
+ */
+enum class FrequencyChannelType : uint8_t
+{
+    DSSS = 0,
+    OFDM,
+    CH_80211P
+};
+
+} // namespace ns3
+
+#endif /* WIFI_TYPES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-units.h ns-3.43/src/wifi/model/wifi-units.h
--- ns-3.42/src/wifi/model/wifi-units.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/wifi-units.h	2024-10-09 16:41:10.132656800 -0700
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2024
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors: Jiwoong Lee <porce@berkeley.edu>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_UNITS_H
+#define WIFI_UNITS_H
+
+#include <cstdint>
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of the SI units (as weak types aliases) used across wifi module
+ */
+
+namespace ns3
+{
+
+using mWatt_u = double;       //!< mWatt weak type
+using Watt_u = double;        //!< Watt weak type
+using dBW_u = double;         //!< dBW weak type
+using dBm_u = double;         //!< dBm weak type
+using dB_u = double;          //!< dB weak type
+using dBr_u = dB_u;           //!< dBr weak type
+using Hz_u = double;          //!< Hz weak type
+using MHz_u = double;         //!< MHz weak type
+using meter_u = double;       //!< meter weak type
+using ampere_u = double;      //!< ampere weak type
+using volt_u = double;        //!< volt weak type
+using degree_u = double;      //!< degree weak type (angle)
+using joule_u = double;       //!< joule weak type
+using dBm_per_Hz_u = double;  //!< dBm/Hz weak type
+using dBm_per_MHz_u = double; //!< dBm/MHz weak type
+
+} // namespace ns3
+
+#endif // WIFI_UNITS_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-utils.cc ns-3.43/src/wifi/model/wifi-utils.cc
--- ns-3.42/src/wifi/model/wifi-utils.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-utils.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -33,24 +22,25 @@
 const Time WIFI_TU = MicroSeconds(WIFI_TU_US);
 
 double
-DbToRatio(double dB)
+DbToRatio(dB_u val)
 {
-    return std::pow(10.0, 0.1 * dB);
+    return std::pow(10.0, 0.1 * val);
 }
 
-double
-DbmToW(double dBm)
+Watt_u
+DbmToW(dBm_u val)
 {
-    return std::pow(10.0, 0.1 * (dBm - 30.0));
+    return std::pow(10.0, 0.1 * (val - 30.0));
 }
 
-double
-WToDbm(double w)
+dBm_u
+WToDbm(Watt_u val)
 {
-    return 10.0 * std::log10(w) + 30.0;
+    NS_ASSERT(val > 0.);
+    return 10.0 * std::log10(val) + 30.0;
 }
 
-double
+dB_u
 RatioToDb(double ratio)
 {
     return 10.0 * std::log10(ratio);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-utils.h ns-3.43/src/wifi/model/wifi-utils.h
--- ns-3.42/src/wifi/model/wifi-utils.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/wifi-utils.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -21,6 +10,7 @@
 #define WIFI_UTILS_H
 
 #include "block-ack-type.h"
+#include "wifi-types.h"
 
 #include "ns3/fatal-error.h"
 #include "ns3/nstime.h"
@@ -77,27 +67,27 @@
 /**
  * Convert from dBm to Watts.
  *
- * \param dbm the power in dBm
+ * \param val the value in dBm
  *
  * \return the equivalent Watts for the given dBm
  */
-double DbmToW(double dbm);
+Watt_u DbmToW(dBm_u val);
 /**
  * Convert from dB to ratio.
  *
- * \param db the value in dB
+ * \param val the value in dB
  *
  * \return ratio in linear scale
  */
-double DbToRatio(double db);
+double DbToRatio(dB_u val);
 /**
  * Convert from Watts to dBm.
  *
- * \param w the power in Watts
+ * \param val the value in Watts
  *
  * \return the equivalent dBm for the given Watts
  */
-double WToDbm(double w);
+dBm_u WToDbm(Watt_u val);
 /**
  * Convert from ratio to dB.
  *
@@ -105,7 +95,7 @@
  *
  * \return the value in dB
  */
-double RatioToDb(double ratio);
+dB_u RatioToDb(double ratio);
 /**
  * Return the total Ack size (including FCS trailer).
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/yans-error-rate-model.cc ns-3.43/src/wifi/model/yans-error-rate-model.cc
--- ns-3.42/src/wifi/model/yans-error-rate-model.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/yans-error-rate-model.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/yans-error-rate-model.h ns-3.43/src/wifi/model/yans-error-rate-model.h
--- ns-3.42/src/wifi/model/yans-error-rate-model.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/yans-error-rate-model.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/yans-wifi-channel.cc ns-3.43/src/wifi/model/yans-wifi-channel.cc
--- ns-3.42/src/wifi/model/yans-wifi-channel.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/yans-wifi-channel.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage, <mathieu.lacage@sophia.inria.fr>
  */
@@ -87,9 +76,9 @@
 }
 
 void
-YansWifiChannel::Send(Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, double txPowerDbm) const
+YansWifiChannel::Send(Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, dBm_u txPower) const
 {
-    NS_LOG_FUNCTION(this << sender << ppdu << txPowerDbm);
+    NS_LOG_FUNCTION(this << sender << ppdu << txPower);
     Ptr<MobilityModel> senderMobility = sender->GetMobility();
     NS_ASSERT(senderMobility);
     for (auto i = m_phyList.begin(); i != m_phyList.end(); i++)
@@ -102,14 +91,14 @@
                 continue;
             }
 
-            Ptr<MobilityModel> receiverMobility = (*i)->GetMobility()->GetObject<MobilityModel>();
-            Time delay = m_delay->GetDelay(senderMobility, receiverMobility);
-            double rxPowerDbm = m_loss->CalcRxPower(txPowerDbm, senderMobility, receiverMobility);
+            auto receiverMobility = (*i)->GetMobility()->GetObject<MobilityModel>();
+            const auto delay = m_delay->GetDelay(senderMobility, receiverMobility);
+            const auto rxPower = m_loss->CalcRxPower(txPower, senderMobility, receiverMobility);
             NS_LOG_DEBUG("propagation: txPower="
-                         << txPowerDbm << "dbm, rxPower=" << rxPowerDbm << "dbm, "
+                         << txPower << "dBm, rxPower=" << rxPower << "dBm, "
                          << "distance=" << senderMobility->GetDistanceFrom(receiverMobility)
                          << "m, delay=" << delay);
-            Ptr<NetDevice> dstNetDevice = (*i)->GetDevice();
+            auto dstNetDevice = (*i)->GetDevice();
             uint32_t dstNode;
             if (!dstNetDevice)
             {
@@ -125,28 +114,28 @@
                                            &YansWifiChannel::Receive,
                                            (*i),
                                            ppdu,
-                                           rxPowerDbm);
+                                           rxPower);
         }
     }
 }
 
 void
-YansWifiChannel::Receive(Ptr<YansWifiPhy> phy, Ptr<const WifiPpdu> ppdu, double rxPowerDbm)
+YansWifiChannel::Receive(Ptr<YansWifiPhy> phy, Ptr<const WifiPpdu> ppdu, dBm_u rxPower)
 {
-    NS_LOG_FUNCTION(phy << ppdu << rxPowerDbm);
-    const auto totalRxPowerDbm = rxPowerDbm + phy->GetRxGain();
-    phy->TraceSignalArrival(ppdu, totalRxPowerDbm, ppdu->GetTxDuration());
+    NS_LOG_FUNCTION(phy << ppdu << rxPower);
+    const auto totalRxPower = rxPower + phy->GetRxGain();
+    phy->TraceSignalArrival(ppdu, totalRxPower, ppdu->GetTxDuration());
     // Do no further processing if signal is too weak
     // Current implementation assumes constant RX power over the PPDU duration
     // Compare received TX power per MHz to normalized RX sensitivity
-    uint16_t txWidth = ppdu->GetTxChannelWidth();
-    if (totalRxPowerDbm < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
+    const auto txWidth = ppdu->GetTxChannelWidth();
+    if (totalRxPower < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
     {
-        NS_LOG_INFO("Received signal too weak to process: " << rxPowerDbm << " dBm");
+        NS_LOG_INFO("Received signal too weak to process: " << rxPower << " dBm");
         return;
     }
     RxPowerWattPerChannelBand rxPowerW;
-    rxPowerW.insert({{{0, 0}, {0, 0}}, DbmToW(totalRxPowerDbm)}); // dummy band for YANS
+    rxPowerW.insert({{{{0, 0}}, {{0, 0}}}, (DbmToW(totalRxPower))}); // dummy band for YANS
     phy->StartReceivePreamble(ppdu, rxPowerW, ppdu->GetTxDuration());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/yans-wifi-channel.h ns-3.43/src/wifi/model/yans-wifi-channel.h
--- ns-3.42/src/wifi/model/yans-wifi-channel.h	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/yans-wifi-channel.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage, <mathieu.lacage@sophia.inria.fr>
  */
@@ -20,6 +9,8 @@
 #ifndef YANS_WIFI_CHANNEL_H
 #define YANS_WIFI_CHANNEL_H
 
+#include "wifi-units.h"
+
 #include "ns3/channel.h"
 
 namespace ns3
@@ -76,14 +67,14 @@
     /**
      * \param sender the PHY object from which the packet is originating.
      * \param ppdu the PPDU to send
-     * \param txPowerDbm the TX power associated to the packet, in dBm
+     * \param txPower the TX power associated to the packet
      *
      * This method should not be invoked by normal users. It is
      * currently invoked only from YansWifiPhy::StartTx.  The channel
      * attempts to deliver the PPDU to all other YansWifiPhy objects
      * on the channel (except for the sender).
      */
-    void Send(Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, double txPowerDbm) const;
+    void Send(Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, dBm_u txPower) const;
 
     /**
      * Assign a fixed random variable stream number to the random variables
@@ -109,9 +100,9 @@
      *
      * \param receiver the device to which the packet is destined
      * \param ppdu the PPDU being sent
-     * \param txPowerDbm the TX power associated to the packet being sent (dBm)
+     * \param txPower the TX power associated to the packet being sent
      */
-    static void Receive(Ptr<YansWifiPhy> receiver, Ptr<const WifiPpdu> ppdu, double txPowerDbm);
+    static void Receive(Ptr<YansWifiPhy> receiver, Ptr<const WifiPpdu> ppdu, dBm_u txPower);
 
     PhyList m_phyList;                  //!< List of YansWifiPhys connected to this YansWifiChannel
     Ptr<PropagationLossModel> m_loss;   //!< Propagation loss model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/yans-wifi-phy.cc ns-3.43/src/wifi/model/yans-wifi-phy.cc
--- ns-3.42/src/wifi/model/yans-wifi-phy.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/model/yans-wifi-phy.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Ghada Badawy <gbadawy@gmail.com>
@@ -58,7 +47,7 @@
 {
     WifiPhy::SetInterferenceHelper(helper);
     // add dummy band for Yans
-    m_interference->AddBand({{0, 0}, {0, 0}});
+    m_interference->AddBand({{{0, 0}}, {{0, 0}}});
 }
 
 YansWifiPhy::~YansWifiPhy()
@@ -93,7 +82,7 @@
 {
     NS_LOG_FUNCTION(this << ppdu);
     NS_LOG_DEBUG("Start transmission: signal power before antenna gain="
-                 << GetPowerDbm(ppdu->GetTxVector().GetTxPowerLevel()) << "dBm");
+                 << GetPower(ppdu->GetTxVector().GetTxPowerLevel()) << "dBm");
     m_signalTransmissionCb(ppdu, ppdu->GetTxVector());
     m_channel->Send(this, ppdu, GetTxPowerForTransmission(ppdu) + GetTxGain());
 }
@@ -105,14 +94,14 @@
     m_signalArrivalCb(ppdu, rxPowerDbm, ppdu->GetTxDuration());
 }
 
-uint16_t
-YansWifiPhy::GetGuardBandwidth(uint16_t currentChannelWidth) const
+MHz_u
+YansWifiPhy::GetGuardBandwidth(MHz_u currentChannelWidth) const
 {
     NS_ABORT_MSG("Guard bandwidth not relevant for Yans");
     return 0;
 }
 
-std::tuple<double, double, double>
+std::tuple<dBr_u, dBr_u, dBr_u>
 YansWifiPhy::GetTxMaskRejectionParams() const
 {
     NS_ABORT_MSG("Tx mask rejection params not relevant for Yans");
@@ -120,9 +109,9 @@
 }
 
 WifiSpectrumBandInfo
-YansWifiPhy::GetBand(uint16_t /*bandWidth*/, uint8_t /*bandIndex*/)
+YansWifiPhy::GetBand(MHz_u /*bandWidth*/, uint8_t /*bandIndex*/)
 {
-    return {{0, 0}, {0, 0}};
+    return {{{0, 0}}, {{0, 0}}};
 }
 
 FrequencyRange
@@ -137,4 +126,12 @@
     return {0, 0};
 }
 
+void
+YansWifiPhy::FinalizeChannelSwitch()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(GetOperatingChannel().GetNSegments() > 1,
+                    "operating channel made of non-contiguous segments cannot be used with Yans");
+}
+
 } // namespace ns3
